<template>
    <v-container>
        <v-card elevation="10">
            <v-card-title class="cyan darken-4">
                <v-row justify="center">
                    <span class="display-1 font-weight-light white--text">Login</span>
                </v-row>
            </v-card-title>
            <v-card-text class="pt-6">
                <response-alert v-bind:error="error"></response-alert>
                <v-form ref="loginForm" lazy-validation>
                    <v-text-field label="Email" name="email" v-model="loginForm.email"
                                  prepend-icon="mdi-account-box" type="text" :rules="rule.email"/>
                    <v-text-field id="password" label="Password" v-model="loginForm.password"
                                  name="password" prepend-icon="mdi-lock"
                                  :type="passwordShow ? 'text' : 'password'"
                                  :append-icon="passwordShow ? 'mdi-eye' : 'mdi-eye-off'"
                                  @click:append="passwordShow = !passwordShow"
                                  :rules="rule.password"/>
                </v-form>
            </v-card-text>
            <v-card-actions>
                <v-btn class="cyan darken-4 white--text" block @click="login">Login</v-btn>
            </v-card-actions>
            <v-card-text class="caption">
                <span>Don't have account? </span>
                <router-link to="/register"><span>Sign Up</span></router-link>
            </v-card-text>
        </v-card>
    </v-container>
</template>

<script>
    import ResponseAlert from "./ResponseAlert";

    export default {
        name: "LoginForm",
        components: {ResponseAlert},
        data() {
            return {
                loginForm: {
                    email: '',
                    password: '',
                },
                rule: {
                    email: [
                        v => !!v || 'Email is required',
                        v => /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'E-mail must be valid',
                    ],
                    password: [
                        v => !!v || 'Password is required',
                        v => (v && v.length > 8) || 'Name must be more than 8 characters',
                    ],
                },
                error: "",
                passwordShow: false,
                isLoading: false,
            }
        },
        methods: {
            login() {
                if (this.$refs.loginForm.validate()) {
                    this.changeLoading()
                    this.$store.dispatch('login', this.loginForm).then(() => {
                        this.changeLoading()
                        this.$router.push({name: 'Home'})
                    }).catch(() => {
                        this.errorResponse("Email or Password Not Correct")
                    }).finally(() => {
                        this.changeLoading()
                    })
                }
            },
            errorResponse(error) {
                this.error = error
            },
            changeLoading() {
                this.$emit('isLoading')
            }
        }
    }
</script>

<style scoped>

</style>